apiVersion: apps/v1
kind: Deployment
metadata:
  name: {{ .Release.Name }}-spring-app
  labels:
    app: spring-app
spec:
  replicas: 1
  selector:
    matchLabels:
      app: spring-app
  template:
    metadata:
      labels:
        app: spring-app
    spec:
      initContainers:
        - name: wait-for-database
          image: busybox
          command: ["/bin/sh", "-c", "/{{ .Release.Name }}-check-database-script/init-script.sh", "{{ .Release.Name }}-mysql-service", "3306"]
          volumeMounts:
            - name: {{ .Release.Name }}-check-database-script
              mountPath: /{{ .Release.Name }}-check-database-script
      volumes:
        - name: {{ .Release.Name }}-check-database-script
          configMap:
            name: {{ .Release.Name }}-check-database-script
            defaultMode: 0744 
          
      containers:
        - name: spring-app
          image: mhmadabuzaid99/firstproject:240117-2eb008e
          env:
            - name: SPRING_DATASOURCE_USERNAME
              value: {{ .Values.spring.SPRING_DATASOURCE_USERNAME }}
            - name: SPRING_DATASOURCE_PASSWORD
              value: {{ .Values.spring.SPRING_DATASOURCE_PASSWORD }}
          ports:
            - containerPort: 8070
              name: http
          resources:
            requests:
              memory: "128Mi"
              cpu: "500m"
            limits:
              memory: "256Mi"
              cpu: "800m"
          readinessProbe:
            httpGet:
              path: /actuator/health  
              port: 8070
            initialDelaySeconds: 5
            periodSeconds: 10
          livenessProbe:
            httpGet:
              path: /actuator/health
              port: 8070
            initialDelaySeconds: 10
            periodSeconds: 20

---
apiVersion: v1
kind: Service
metadata:
  name: {{ .Release.Name }}-spring-app-service
spec:
  type: NodePort
  selector:
    app: spring-app
  ports:
    - protocol: TCP
      port: 8070
      targetPort: 8070
      nodePort: {{ .Values.service.nodePort | default 30100 }}
